# GetResponse REST Web Service Interface

GetResponse API gives you basically the same functionality as in our web panels - you can perform the same set of actions: manage campaigns, newsletters, gather statistics and more (and yes we have segments in here!).

## API Endpoint

Api endpoint (or base url) is always the same for all retail users and looks like follows:

```
https://api.getresponse.com/v3
```

The only thing to remember is that the last part of it (v3 in this case) is the version number of our API. If in the future we introduce some backward incompatible changes we will increment our API version to give you time to migrate from v3 to (let's say) v4. But don't worry we will keep stable version for a long time and most of future updates will be backward compatible.

## GetResponse MAX platform

For GetResponse MAX platform users endpoint looks different. There are two different url's and any GetResponse MAX user who wants to connect to our api should contact his account manager and which one he should use.

- ```https://api3.getresponse360.pl/v3```
- ```https://api3.getresponse360.com/v3```

## Authentication

All request you want to send to our API must contain authentication information. For example, if your api-key is: `84fsne83yrths947r6sfgg7w4he8`, then the custom authentication header should look like:
```
X-Auth-Token: api-key 84fsne83yrths947r6sfgg7w4he8
```
**For security reasons, unused API keys expire after 90 days. When that happens, you&rsquo;ll need to generate a new key to use our API.**
For more detailed information, mobile authentication and GetResponse MAX platform authentication please, go to our [authentication](authentication.md) page

## Basics

This is REST API, all request follows REST rules in terms of resource naming convention, use of HTTP method as action description and use of custom headers to convey additional infomration.

In order to correctly configure your app you need to remember couple of things.

### Methods (HTTPS)

We accept 3 methods GET, POST and DELETE. Every POST request **MUST HAVE** Content-Type header. Currently we accept only 'application/json' content-type

GET if to obtain information. There should not be any "body" data sent with that request. This will not trigger error, but we just simply don't look there in GET request. Only query string parameters ale allowed. This request will never change anything, you can call it as many times as you want. It is called that GET is IDEMPOTENT request.

POST is to add new or modify existing information. If request url doesn't contain resource ID then we will treat that as new data that must be inserted. If you want to modify existing data you need to specify an ID in the Rrequest URL (like POST /contacts/hg5fF). POST is NOT IDEMPOTENT, you need to be carefull to not send the same request twice...

DELETE is only to remove infomration. As a general rule we do not allow to add any "body" data to that type of request nor we allow any query string. This should be just simply DELETE /contacts/hg5fF.

### Resources and Representations

We present data as JSON strings. Those information are named "representation" of a "resource". Each url in our API represents an "resource".

Each representation has its own unique ID - naming convention is very easy: ID of a newsletters is called newsletterId :). We stick to json **camelCase** for field names in json data. When you call **GET /newsletters/V** we will return json data which represents a resource called "newsletter" where it's ID is equal to 'V'.&nbsp;

When you call GET /newsletters we will return a **Collection** of resources. This is simply a list of resources representations presented as json array. You need to remember that in a collection we could ommit some of the fileds that are there in single resource. You should treat collection as a brief information of a resource not a full package :).

When you call POST /newsletters you need to send to us the same structure of json-encoded representation of a newsletter resource. This is very important! If you change name of a field, add some new fields of ommit some of the mandatory fields we will return 400 response with special "error" resource which will contain all validation errors that we discovered in your request. Sometimes you can ommit the field (if it isn't mandatory), but if you set some field with empty value we will treat this as normal and simply set this value to empty string or null. If you don't want to modify some field just don't include it in json representation.

---

# Quick Start

The shortest path to a working GetResponse API integration for AI agents and developers. Create your first campaign (contact list), then read it back. If both requests succeed, your integration is working and you’re ready to explore the [API Reference](https://apireference.getresponse.com/).

## Prerequisites

- An API key generated in your account: [https://app.getresponse.com/api](https://app.getresponse.com/api)
- Every request must include your API key in the `X-Auth-Token` header, prefixed with `api-key`. Replace `YOUR_API_KEY` with the API key from your account:

```
X-Auth-Token: api-key YOUR_API_KEY
```

- Base URL (use the base URL that corresponds to your account type):

| Account type | Base URL |
| --- | --- |
| GetResponse (SMB) | `https://api.getresponse.com/v3` |
| GetResponse MAX (PL) | `https://api3.getresponse360.pl/v3` |
| GetResponse MAX (US) | `https://api3.getresponse360.com/v3` |

**For MAX accounts:**

Ask your account manager if you don’t know which domain your account is hosted on. MAX requests must also include an `X-Domain` header with your account domain, e.g. `X-Domain: example.com`. See [Authentication](authentication) for details.

**The examples below use the SMB base URL. For MAX accounts, use your MAX base URL instead.**

## Step 1: Create campaign

Call [POST /campaigns](https://apireference.getresponse.com/#operation/createCampaign) to create a campaign (contact list). Only `name` is required. It must be unique in your account, be 3-64 characters long, and cannot contain `/`, `\`, `@`, `[` or `]`.

```bash
curl -X POST \
     https://api.getresponse.com/v3/campaigns \
     -H 'X-Auth-Token: api-key YOUR_API_KEY' \
     -H 'Content-Type: application/json' \
     -d '{
       "name": "quick_start_list"
   }'
```

Here’s an example of the same call from a GetResponse MAX (PL) account:

```bash
curl -X POST \
     https://api3.getresponse360.pl/v3/campaigns \
     -H 'X-Auth-Token: api-key YOUR_API_KEY' \
     -H 'X-Domain: example.com' \
     -H 'Content-Type: application/json' \
     -d '{
       "name": "quick_start_list"
   }'
```

A `201 Created` response returns the full campaign resource, including its `campaignId`. Copy the `campaignId` for the next step:

```json
{
    "campaignId": "Ls3jm",
    "href": "https://api.getresponse.com/v3/campaigns/Ls3jm",
    "name": "quick_start_list",
    "techName": "17e911d2d2e32f9a05d722241bdecb45",
    "languageCode": "PL",
    "isDefault": "false",
    "createdOn": "2024-05-14T09:12:31+0000",
    "confirmation": { ... },
    "profile": { ... },
    "postal": { ... },
    "optinTypes": {
        "api": "double",
        "email": "single",
        "import": "single",
        "webform": "double"
    },
    "subscriptionNotifications": { ... }
}
```

If the name is already in use in your account, you’ll get a `409 Conflict` response with error code `1008`. Choose a different name and try again. For more information on possible errors, see [Errors](errors).

## Step 2: Retrieve campaign

Call [GET /campaigns/{campaignId}](https://apireference.getresponse.com/#operation/getCampaign) with the `campaignId` returned in step 1 to confirm that the campaign exists.

```bash
curl -X GET \
     https://api.getresponse.com/v3/campaigns/Ls3jm \
     -H 'X-Auth-Token: api-key YOUR_API_KEY'
```

A `200 OK` response with the same `campaignId` and `name` confirms your integration is working end to end. An invalid or missing API key returns `401 Unauthorized` with error code `1014`. For more information on possible errors, see [Errors](errors).

## Next steps

- [Authentication](authentication) for OAuth 2.0 and GetResponse MAX headers
- [Adding contacts](case-study/adding-contacts) to add a contact to the new campaign

---

# GetResponse MCP Server

Connect AI assistants such as Claude, Cursor, VS Code, and ChatGPT to GetResponse through the Model Context Protocol.

The GetResponse MCP server lets compatible AI assistants work with your contacts, lists, newsletters, AI campaigns, and campaign statistics through standardized tools.

## How MCP works

The Model Context Protocol (MCP) is a standard for connecting AI assistants to external systems. After you add the GetResponse server to an MCP-compatible client, the client discovers the available tools and can use them to complete tasks you request.

The GetResponse MCP server uses Streamable HTTP and OAuth 2.0. When you connect, your client opens the GetResponse sign-in and authorization flow. You don't need to create or paste an API key.

Actions run with the permissions of the GetResponse account you authorize. Review proposed changes before approving actions that create or update account data.

## Getting started

1. [Choose the MCP endpoint](mcp/endpoints) for your GetResponse account.
2. Follow the [agent setup instructions](mcp/configuration) for your MCP client.
3. Sign in to GetResponse and authorize the connection when prompted.

## Available tools

### Contacts and lists

- **`get_campaigns`** — Returns the contact lists defined in your account.
- **`get_custom_fields_list`** — Returns a paginated list of custom fields.
- **`get_recently_added_contacts`** — Returns recently added contacts.
- **`get_contacts_by_name`** — Searches for contacts by name.
- **`get_contacts_by_campaign`** — Searches for contacts in a specified list.
- **`get_contacts_who_received_any_message_in_last_days`** — Returns contacts who received a message during the specified number of days.
- **`get_contacts_who_did_not_open_any_message_in_last_days`** — Returns contacts who didn't open a message during the specified number of days.
- **`get_contacts_who_clicked_any_link_in_any_message_in_last_days`** — Returns contacts who clicked a link during the specified number of days.
- **`get_contacts_who_opened_any_message_in_last_days`** — Returns contacts who opened a message during the specified number of days.
- **`get_contacts_who_have_custom_field_assigned`** — Returns contacts that have a specified custom field assigned.

### Newsletters

- **`get_email_addresses_list`** — Returns the email addresses available to the current user.
- **`get_newsletter_content`** — Returns the content of a specified newsletter.
- **`get_drafts_list`** — Returns a paginated list of newsletter drafts.
- **`create_newsletter`** — Creates a newsletter.
- **`update_newsletter`** — Updates an existing newsletter.
- **`create_newsletter_with_content`** — Creates a newsletter with AI-generated content.

### Newsletter statistics

- **`get_general_performance`** — Returns a newsletter statistics summary for the specified conditions.
- **`get_broadcasts_sent_between_dates`** — Returns newsletters sent between specified dates.
- **`get_single_newsletter_performance_summary`** — Returns the performance summary for a specified newsletter.

### AI campaigns

- **`create_marketing_campaign`** — Creates a marketing campaign with a landing page, newsletter, and welcome message.

---

# Agent setup

You can connect any MCP-compatible client that supports remote Streamable HTTP servers and OAuth 2.0.

The examples below use the standard GetResponse endpoint:

```
https://mcp.getresponse.com/
```

GetResponse MAX customers must replace this URL with their account-specific [MCP endpoint](endpoints). Enter the selected URL exactly as shown, without adding `/mcp`.

Authentication is handled through OAuth 2.0. After adding the server, follow the browser-based GetResponse sign-in and authorization flow opened by your client.

## Claude

Custom connectors are available on Free, Pro, Max, Team, and Enterprise plans. Free accounts can add one custom connector.

1. Open **Customize > Connectors** in Claude.
2. Select the plus button, then **Add custom connector**.
3. Enter your MCP endpoint as the remote MCP server URL and select **Add**.
4. Find the GetResponse connector and select **Connect**, then sign in to GetResponse and authorize the connection.

On Team and Enterprise plans, an Owner must first add the connector under **Organization settings > Connectors > Add > Custom > Web**. Organization members can then connect to it under **Customize > Connectors**.

## Claude Code

Run the following command in your terminal:

```bash
claude mcp add --transport http getresponse https://mcp.getresponse.com/
```

For a GetResponse MAX account, replace `https://mcp.getresponse.com/` with your account-specific endpoint. Start Claude Code, run `/mcp`, select `getresponse`, and complete the GetResponse authorization flow.

## VS Code

For a standard GetResponse account, use [one-click installation](https://vscode.dev/redirect/mcp/install?name=getresponse&config=%7B%22type%22%3A%22http%22%2C%22url%22%3A%22https%3A%2F%2Fmcp.getresponse.com%2F%22%7D).

Run **MCP: Add Server** from the Command Palette, select HTTP as the server type, enter your MCP endpoint, and choose **Global** or **Workspace** as the target.

You can also add the server manually to `.vscode/mcp.json`:

```json
{
  "servers": {
    "getresponse": {
      "type": "http",
      "url": "https://mcp.getresponse.com/"
    }
  }
}
```

For a GetResponse MAX account, replace the value of `url` with your account-specific endpoint. When VS Code first connects to the server, complete the GetResponse authorization flow in your browser.

## Cursor

For a standard GetResponse account, use [one-click installation](https://cursor.com/install-mcp?name=GetResponse&config=eyJ1cmwiOiJodHRwczovL21jcC5nZXRyZXNwb25zZS5jb20vIn0%3D).

Add the server to `.cursor/mcp.json` for the current project or `~/.cursor/mcp.json` to make it available globally:

```json
{
  "mcpServers": {
    "getresponse": {
      "url": "https://mcp.getresponse.com/"
    }
  }
}
```

For a GetResponse MAX account, replace the value of `url` with your account-specific endpoint. Open **Customize** in Cursor, enable the server, and complete the GetResponse authorization flow.

## ChatGPT

Developer mode is available to Pro, Plus, Business, Enterprise, and Education accounts on the web.

1. Open **Settings > Security and login** and enable **Developer mode**.
2. Go to [ChatGPT Plugins](https://chatgpt.com/plugins).
3. Select the plus button and create a developer-mode app for the remote MCP server. Enter `GetResponse` as the name, use your [MCP endpoint](endpoints) as the server URL, and select OAuth authentication.
4. Sign in to GetResponse and authorize the app. After it is created, the app appears under **Drafts** in the app settings.
5. In a new conversation, open the Plus menu, select **Developer mode**, and enable the GetResponse app.

The available tools are described on the [GetResponse MCP Server](../mcp) page.

---

# MCP endpoints

Use the endpoint that matches your GetResponse account type.

| Account type | MCP endpoint |
| --- | --- |
| GetResponse | `https://mcp.getresponse.com/` |
| GetResponse MAX | `https://<your-account>.mcp.getresponse360.pl` |
| GetResponse MAX | `https://<your-account>.mcp.getresponse360.com` |

For GetResponse MAX, ask your account manager which endpoint to use and what value should replace `<your-account>`.

Enter the endpoint at its root. Don't append `/mcp` or an API version path.

---

# Authentication

API can be accessed by authenticated users only. This means that every request must be signed with your credentials. We offer two methods of authentication: API Key and OAuth 2.0. API key is our primary method and should be used in most cases. GetResponse MAX clients have to send an ```X-Domain``` header in addition to the API key. Supported OAuth 2.0 flows are: Authorization Code, Client Credentials, Implicit, and Refresh Token.

## API key

Follow these steps to send an authentication request:

- Find your unique and secret API key in the panel: [https://app.getresponse.com/api](https://app.getresponse.com/api)
- Add a custom ```X-Auth-Token``` header to all your requests. For example, if your API key is ```jfgs8jh4ksg93ban9Dfgh8```, the header will look like this:

```
X-Auth-Token: api-key jfgs8jh4ksg93ban9Dfgh8
```
::: warning
For security reasons, unused API keys expire after 90 days. When that happens, you&rsquo;ll need to generate a new key to use our API.
:::

#### Example authenticated request
```bash
$  curl -H "X-Auth-Token: api-key jfgs8jh4ksg93ban9Dfgh8" https://api.getresponse.com/v3/accounts
```

## OAuth 2.0

To use OAuth 2.0 authentication, you need to get an "Access Token". For more information on how to obtain a token, head to our dedicated page: [OAuth 2.0](authentication/oauth2.md)

To authenticate a request using an Access Token, set the value of ```Authorization``` header to "Bearer" followed by the Access Token.

#### Example

If the Access Token is ```jfg93baDfgh8n9Ds8jh4ksg93ban9Dfgh8```
```
Authorization: Bearer jfg93baDfgh8n9Ds8jh4ksg93ban9Dfgh8
```
## GetResponse MAX

GetResponse MAX customers need to take an extra step to authenticate the request. All requests have to be sent with an ```X-Domain``` header that contains the client's domain. For example:
```
X-Domain: example.com
```

Please note that the header must contain only the domain name, without the protocol identifier (```http://``` or ```https://```).

### X-Parent-Login header

A user can be in one or more accounts (parent accounts). The ```X-Parent-Login``` header allows you to limit API requests to a specific parent account.

For example, a user is assigned to two parent accounts with logins: ```abc@getresponse.com``` and ```xyz@getresponse.com```.

If the ```X-Parent-Login: abc@getresponse.com``` header is set in API requests, they'll be made only for the parent account with the login```abc@getresponse.com```.

If a request is made with the header ```X-Parent-Login: xyz@getresponse.com```, it will return information only for the parent account with the login ```xyz@getresponse.com```.

---

# Oauth 2.0

## Register your own application

If you want to use an OAuth flow to authorize your application, first register your application here: <https://app.getresponse.com/authorizations>

You need to provide a name, short description, and redirect URL.

## Choosing grant flow

Once your application is registered, you can click on it to see your <font color="red">client_id</font> and <font color="red">client secret</font>. They're basically a login and password for your application, so be sure not to share them with anyone.

Next, decide which authentication flow (grant type) you want to use. Here are your options:
- choose the Authorization Code flow if your application is server-based (you have a server with its own domain and server-side code),
- choose the Implicit flow if your application is based mostly on JavaScript or client-side code,
- choose the Client Credential flow if you want to test your application or access your GetResponse account,
- implement the Refresh Token flow to handle token expiration if you use the Authorization Code flow.



## Authorization Code flow
First, your application must redirect the resource owner to the following URL:
```
https://app.getresponse.com/oauth2_authorize.html?response_type=code&client_id=_your_client_id_&state=xyz

```
The <font color="red">state</font> parameter is there for security reasons and should be a random string. When the resource owner grants your application access to the resource, we will redirect the browser to the redirect URL you specified in the application settings and attach the same state as the parameter. Comparing the state parameter value ensures that the redirect was initiated by our system.


#### Example redirect with authorization code
```
https://myredirecturi.com/cb?code=ed17c498bfe343175cd7684c5b09979f2875b25c&state=xyz

```
The code parameter is an authorization code that you can exchange for an access token within 10 minutes, after which time it expires.


#### Exchanging authorization code for the access token
Here's an example request to exchange authorization code for the access token:

```
$  curl -u client_id:client_secret https://api.getresponse.com/v3/token \
        -d "grant_type=authorization_code&code=ed17c498bfe343175cd7684c5b09979f2875b25c"
```
::: tip
Remember to replace <font color="red">client_id</font> and <font color="red">client_secret</font> with your OAuth application credentials.
:::

#### Example response
```json
  {
      "access_token": "03807cb390319329bdf6c777d4dfae9c0d3b3c35",
      "expires_in": 3600,
      "token_type": "Bearer",
      "scope": null,
      "refresh_token": "170d9f64e781aaa6b3ba036083faba71b2fc4e6c"
  }
```

## Client Credentials flow
This flow is suitable for development purposes, especially in cases when you need to quickly access API to create some functionality. You can get the access token with a single request:

#### Request
```
$  curl -u client_id:client_secret https://api.getresponse.com/v3/token \
        -d 'grant_type=client_credentials'
```
::: tip
Remember to replace <font color="red">client_id</font> and <font color="red">client_secret</font> with your OAuth application credentials.
:::
#### Response
```json
  {
      "access_token": "e2222af2851a912470ec33c9b4de1ea3a304b7d7",
      "expires_in": 86400,
      "token_type": "Bearer",
      "scope": null
  }
```
You can also go to <https://app.getresponse.com/authorizations>, click the action button for your application, and select "Credentials code". This will open a popup with a generated access token. You can then use the access token to authenticate your requests, for example:

```
$  curl -H "Authorization: Bearer e2222af2851a912470ec33c9b4de1ea3a304b7d7" https://api.getresponse.com/v3/from-fields
```

## Implicit flow
First, your application must redirect the resource owner to the following URL:

```
https://app.getresponse.com/oauth2_authorize.html?response_type=token&client_id=_your_client_id_&redirect_uri=https://myredirecturi.com/cb&state=xyz

```

When the resource owner grants your application access to the resource, we will redirect the owner to the URL that was specified in the request.

There is no code exchange process because, unlike the Authorization Code flow, the redirect already has the access token in the parameters.

#### Example redirect
```
https://myredirecturi.com/cb#access_token=2YotnFZFEjr1zCsicMWpAA&state=xyz&token_type=bearer&expires_in=3600
```

## Refresh Token flow
You need to refresh your access token if you receive this error message as a response to your request:
```json
  {
      "httpStatus": 401,
      "code": 1014,
      "codeDescription": "Problem during authentication process, check headers!",
      "message": "The access token provided is expired",
      "moreInfo": "https://apidocs.getresponse.com/en/v3/errors/1014",
      "context": {
          "sentToken": "b8b1e961a7f9fd4cc710d5d955e09c15a364ab71"
      }
  }
```
If you are using the Authorization Code flow, you need to use the refresh token to issue a new access token/refresh token pair by making the following request:
```
$  curl -u client_id:client_secret https://api.getresponse.com/v3/token \
       -d 'grant_type=refresh_token&refresh_token=170d9f64e781aaa6b3ba036083faba71b2fc4e6c'
```
::: tip
Remember to replace <font color="red">client_id</font> and <font color="red">client_secret</font> with your OAuth application credentials.
:::
The response you'll get will look like this:

```json
  {
      "access_token": "890fdsa2f5d7b189fc4e6c4b1d170d9f591238ss",
      "expires_in": 86400,
      "token_type": "Bearer",
      "scope": null,
      "refresh_token": "170d9f64e781aaa6b3ba036083faba71b2fc4e6c"
  }
```
## GetResponse MAX
There are some differences when authenticating GetResponse MAX users:

- the application must redirect to a page in the client's custom domain, for example: `https://custom-domain.getresponse360.com/oauth2_authorize.html`
- token requests have to be sent to one of the GetResponse MAX APIv3 endpoints (depending on the client's environment),
- token requests have to include an X-Domain header,
- the application has to be registered in a GetResponse MAX account within the same environment.

---

# Errors
## Error Code: **1** (Internal error) {#1}

### HTTP status Code: 500

Something went wrong on our side, and there is nothing you can do to fix that. We will get notified about all errors immediately, but if you are experiencing this often then please let us know!

These errors are connected to system failures, database connection lost or DDoS attack.

## Error Code: **1000** (General error of validation process) {#1000}

### HTTP status Code: 400

This is a general validation error - usually you will see this if there is more than one type of validation error in request message. We will give you more detailed information in the 'context' part of the error response. Please look there to see what went wrong.

## Error Code: **1001** (Resource that is related to given resource cannot be found) {#1001}

### HTTP status Code: 400

Some of our resources are connected to other resources - you cannot get one without the other. If in your requests you specify ID of that related resources that will be invalid or nonexistent, then we cannot fulfill the request and response with this error code is our way to notify you about it.

Common examples of this error are:

*   creating a new newsletter using invalid campaign
*   searching for valid clicktractId but using wrong autoresponder
*   adding contact with nonexistent custom-field

## Error Code: **1002** (Resource state forbids that kind of action) {#1002}

### HTTP status Code: 400

Whatever you tried to do, this cannot be accomplished. There are many reasons:

*   You tried to add contact that is already on your blacklist
*   You tried to add contact, but the email address is invalid (domain don't exist or domain don't have this email registered)
*   You tried to add contact that was previously deleted or bounced
*   You tried to send draft but given message is not a draft
*   You tried to set not active from-field as a default one

We always add more information in the context or description section in the error response.

## Error Code: **1003** (Parameter has wrong format) {#1003}

### HTTP status Code: 400

This is validation error. There are many other validation types, but this particular checks if value of parameters you send in request are in proper type.

Generally we check:

*   resource ID format
*   email address syntax
*   IP address syntax
*   reserved words
*   forbidden words
*   checks against dictionary (e.g. opt-in type values during adding contact)
*   date format
*   phone number format

## Error Code: **1004** (Wrong number of values for multi-value parameter (hash, table)) {#1004}

### HTTP status Code: 400

Sometimes we expect that parameters should be an array (table) with multiple values inside. There can be limits (max or min) to number of values inside that parameter, and when you see this error, you go past that limits. We will tell you what are the limits in any particular case - just take a look into 'context' section of error response.

## Error Code: **1005** (Parameter has empty value) {#1005}

### HTTP status Code: 400

We sometimes expect that some fields must have value in them, but you sent us a parameter without it. We will tell you where we expect a value - look at 'context' section in error response.

## Error Code: **1006** (Parameter has wrong type) {#1006}

### HTTP status Code: 400

Sometimes we require that some parameters have values of some type. We check mostly primitives (string, integer, boolean). We will return bad value and name of a parameter in the 'context' section of the error response.

## Error Code: **1007** (Parameter value has incorrect length) {#1007}

### HTTP status Code: 400

Some parameters have restriction on how long or short they can be. We always return in the 'context' section what is the limit in that case.
## Error Code: **1008** (There is another resource with the same value of unique property) {#1008}

### HTTP status Code: 409

We cannot add resource because there is already resource with the same unique properties. This can be:

*   autoresponder name
*   contact email in campaign
*   campaign name
*   custom-field name
*   goal name
*   goal URL
*   goal update when
*   goal profile name
*   search-contacts name
*   suppression name

## Error Code: **1009** (Resource you tried to manipulate is used somewhere and this manipulation is forbidden) {#1009}

### HTTP status Code: 400

Sometimes it is forbidden to edit some resource because it is used somewhere else.

Examples:

*   remove custom-field when it is used on webforms
*   remove custom-field when it is used in search-contacts (segmentation)
*   remove from-field that is used
*   removing goal when it is used in search-contacts (segmentation)
*   removing goal-profile when it is used in search-contacts (segmentation)
*   removing newsletter when it is used in search-contacts (segmentation)
*   removing search-contacts (segments) when it is used as a target for sending messages

## Error Code: **1010** (Error in external resources) {#1010}

### HTTP status Code: 400

This error is related to any external checks we need to do in order to fulfill your request. If for any reason this external call fails we return this error and try to add some detailed information to 'context' section in the error response. One example could be a check during GoalProfile creation.

## Error Code: **1011** (Message is already in "sending" mode, you cannot change its properties) {#1011}

### HTTP status Code: 400

You tried to edit newsletter that is already being sent.

## Error Code: **1012** (Error during parsing message content) {#1012}

### HTTP status Code: 400

Error in the message body. We tried to analyze message body and cannot find one of mandatory merge\_word. We will try to give you more details in 'context' section in the error response.

## Error Code: **1013** (Resource with given ID cannot be found) {#1013}

### HTTP status Code: 404

There is simply no resource of given ID.

## Error Code: **1014** (Problem during authentication process) {#1014}

### HTTP status Code: 403

This error may be returned for a couple of different reasons:

*   Authorization headers were not sent (check headers if there is X-Auth-Token header sent during every request)
*   Authorization headers were ok, but there is no token (it should be passed as X-Auth-Token: token\_type your\_api\_key)
*   Authorization headers were ok, but token type is unknown (it should be passed as X-Auth-Token: api-key your\_api\_key)
*   Headers were ok, but api-key is invalid

## Error Code: **1015** (Too many request to API, quota reached) {#1015}

### HTTP status Code: 429

In terms of this error, there could be a couple of reasons you should look for:

* You reached quota limit and throttling system was activated
* Our monitoring system recognised your requests pattern as a potential threat and temporarily disabled access to the API. It will be enabled in next 15 minutes. Please contact us, we will check and explain what could be wrong.
* Our monitoring system recognised you requests pattern as a risky behaviour and permanently disabled access to the API. Blockade could be removed only by our support.
* Restrictions policy for that account forbids access from this IP address. Please contact with our support.

## Error Code: **1016** (Too many request to API or suspected behaviour, API was temporarily blocked, please wait) {#1016}

### HTTP status Code: 403
## Error Code: **1017** (Suspected behaviour, API was permanently blocked, please contact with our support) {#1017}

### HTTP status Code: 403
## Error Code: **1018** (Your IP was blocked) {#1018}

### HTTP status Code: 403
## Error Code: **1019** (Service unavailable) {#1019}

### HTTP status Code: 503

The server is currently unable to handle the request due to a maintenance.

## Error Code: **1021** (There is something wrong with your request headers) {#1021}

### HTTP status Code: 400

This error is all about your request headers.

In most cases you should send us at least:

* X-Auth-Token - if you are using api-key authorization
* Authorization - if you are using oAuth2 authorization
* Content-Type - this should be sent always, and for now it should be set to 'application/json'

If you get this error, please check you request headers.

## Error Code: **1023** (Access forbidden) {#1023}

### HTTP status Code: 403

The account or collaborator account you are using does not have access to permission or campaign required to perform the requested action. Please contact account owner (if you are a collaborator) for additional permissions or our support team (if you are the account owner).

## Error Code: **1024** (Domain not found) {#1024}

### HTTP status Code: 404
## Error Code: **1027** (Failed to add contacts. Limit reached. Log in to GetResponse to check your account status) {#1027}

### HTTP status Code: 400
## Error Code: **1028** (Resource is restricted and cannot be modified or deleted) {#1028}

### HTTP status Code: 400
## Error Code: **1029** (Resource property is restricted and cannot be used) {#1029}

### HTTP status Code: 400

---

Limits & throttling
===================

GetResponse API calls are subject to throttling to ensure a high level of service for all users.

Time frame
----------

Time frame is a period of time for which we calculate the API call limits. The limits reset in every time frame.

The time frame duration is **10 minutes**.

Basic rate limits
-----------------

Each user is allowed to make **30,000 API calls per time frame** (10 minutes) and **80 API calls per second**.

Parallel requests limit
-----------------------

It is possible to send up to **10 simultaneous requests**.

Headers
-------

Every API response includes a few additional headers:

*   `X-RateLimit-Limit` – the total number of requests available per time frame
*   `X-RateLimit-Remaining` – the number of requests left in the current time frame
*   `X-RateLimit-Reset` – seconds left in the current time frame

Errors
------

The **429 Too Many Requests** HTTP response code indicates that the limit has been reached. The error response includes `currentLimit` and `timeToReset` fields in the context section, with the total number of requests available per time frame and seconds left in the current time frame respectively.

Reaching the limit
------------------

When you reach the limit, you need to wait for the time specified in `timeToReset` field or `X-RateLimit-Reset` header before making another request.

---

# API Collections

To help you get started faster with the GetResponse API, we provide ready-to-use collections for the most popular API client tools: [Postman](https://www.postman.com/), [Bruno](https://www.usebruno.com/) and the JetBrains IDEs HTTP Client (`.http` files).

Each collection contains a set of pre-configured requests covering the GetResponse API v3 endpoints, so you can explore and test the API without writing any code.

## Postman collection

[Postman](https://www.postman.com/) is a popular API platform for building and using APIs.

- [Download the Postman collection](/getresponse-postman-collection.zip)

### How to use it

1. Download and unzip the collection.
2. Open Postman and go to **Import**.
3. Select the extracted `.json` file.
4. Set up your `X-Auth-Token` (or OAuth 2.0) authentication as described in the [Authentication](authentication) section.

### Example environment

The collection uses [Postman environment variables](https://learning.postman.com/docs/sending-requests/variables/managing-environments/) so you don't have to hardcode your credentials in every request. Below is an example environment file — create your own with these variables (values are anonymized, so replace them with your own data):

```json
{
    "id": "00000000-0000-0000-0000-000000000000",
    "name": "GetResponse API",
    "values": [
        {
            "key": "url",
            "value": "https://api.getresponse.com",
            "enabled": true
        },
        {
            "key": "token",
            "value": "your-api-key",
            "enabled": true
        },
        {
            "key": "domain",
            "value": "your-domain.com",
            "enabled": true
        }
    ],
    "_postman_variable_scope": "environment",
    "_postman_exported_at": "2024-01-01T00:00:00.000Z",
    "_postman_exported_using": "Postman/11.0.0"
}
```

- `url` — the base URL of the API you want to call, e.g. `https://api.getresponse.com` (GetResponse MAX clients should use their own API domain, e.g. `https://api3.getresponse360.pl`).
- `token` — your API key, used in the `X-Auth-Token` header as described in the [Authentication](authentication) section.
- `domain` — required for GetResponse MAX clients only. Your account's domain, sent in the `X-Domain` header. See the [GetResponse MAX](authentication#getresponse-max) section for details.

::: tip NOTE
You can import this file as a new environment in Postman (**Environments** > **Import**), or create a new environment manually and add these variables yourself.
:::

## Bruno collection

[Bruno](https://www.usebruno.com/) is a fast, open-source, git-friendly API client — an alternative to Postman.

- [Download the Bruno collection](/getresponse-bruno-collection.zip)

### How to use it

1. Download and unzip the collection.
2. Open Bruno and choose **Open Collection**.
3. Select the extracted collection folder.
4. Set up your `X-Auth-Token` (or OAuth 2.0) authentication as described in the [Authentication](authentication) section.

### Example environment

Bruno also uses environments to store variables like your API key, so you don't have to hardcode them in every request. The same `url`, `token` and `domain` variables described in the [Postman example environment](#example-environment) above apply here as well — only the way you set them up is different:

1. Open the collection in Bruno.
2. In the top-right corner, open the environment selector and choose **Configure**.
3. Create a new environment (or select an existing one bundled with the collection) and add the `url`, `token` and `domain` variables with your own values.
4. Save the environment and select it from the environment selector so it's used for your requests.

## HTTP Client collection

The [HTTP Client](https://www.jetbrains.com/help/phpstorm/http-client-in-product-code-editor.html) is a tool built into JetBrains IDEs (e.g. PhpStorm, IntelliJ IDEA) that lets you create, edit and run HTTP requests directly from `.http` files, without leaving the IDE.

- [Download the HTTP Client collection](/http.zip)

### How to use it

1. Download and unzip the collection.
2. Open the extracted `http` folder in your JetBrains IDE.
3. Open any `.http` file - each one corresponds to a group of requests (e.g. `Contacts.http`, `Campaigns (Lists).http`).
4. Set up your API key as described below, then select the `dev` environment from the dropdown available in the `.http` file editor before running a request.

### Example environment

The collection comes with two environment files:

- `http-client.env.json` - contains the public `baseUrl` variable.
- `http-client.private.env.json` - contains the `token` variable (your API key).

Open `http-client.private.env.json` and replace the `YOUR_API_KEY_HERE` value with your real API key, as described in the [Authentication](authentication) section. This file should not be shared or committed with a real key.

::: tip NOTE
Some requests use path variables, e.g. `{{contactId}}`, `{{campaignId}}`, etc. Their values are not predefined in the environment - at the top of each `.http` file that uses them, there is a declaration such as `@campaignId = {your campaignId id}`. Replace the value after the `=` sign with your own ID so requests in that file can use it.
:::

::: tip NOTE
All collections are updated occasionally and might not include the newest endpoints.
:::

---

# Dynamic Content

Dynamic content lets you create personalized messages with custom content, like links, dates, or recipients' details.

**Note:** Dynamic content requires coding skills. Talk to a developer if you haven't used a programming language before.

Requirements
------------

Dynamic Content is a programing language, and so it requires strict syntax:

*   There can be only one instruction per tag.
*   The syntax is case-sensitive. Use upper case and lower case as shown in the examples under specific sections.
*   In HTML messages, backticks can be used instead of double quotes.
*   A message may be composed of 1024 parts, where each block of text or a dynamic content tag counts as one part.

Support
-------

Our dynamic content is created and maintained by the **GetResponse DevZone Team**.

[Contact us](https://www.getresponse.com/features/support) if you find any errors or have problems using dynamic content. We're here to help.

---

# Campaign

## Campaign predefined values

Merge-words that are constant in your campaign.
```{{PREDEFINED `my_shop_name`}}```

[Prettifiers](prettifiers.md) are allowed.

Predefined values can be defined on [GetResponse WWW](https://app.getresponse.com/campaigns_predefined_variables.html).
Empty string is inserted into the message on undefined value.

## Campaign or contact or message info

Basic merge-words providing info about campaign, contact or message. Please note that "contact" is called a "subscriber"
in tokens due to backward compatibility.

```md
{{CONTACT `subscriber_name`}}
```

Supported tokens:

* `subscriber_name`
* `subscriber_first_name` – Everything up to first space.
* `subscriber_last_name` – Empty if name doesn’t consist of two parts separated by space.
* `subscriber_email`
* `subscriber_ip`
* `subscriber_origin`
* `campaign_name` – Refers to message's campaign
* `campaign_description` – Refers to message's campaign
* `campaign_from_name` – Refers to message's campaign
* `campaign_from_email` – Refers to message's campaign
* `campaign_reply_to_email` – Refers to message's campaign
* `campaign_link_protocol` – Refers to message's campaign
* `campaign_link_domain` – Refers to message's campaign
* `message_from_name`
* `message_from_email`
* `message_reply_to_email`
* `campaign_id`
* `message_id`
* `subscriber_id`
* `message_name` – Empty in subscription confirmation messages

Prettifiers are allowed.

Empty string is inserted into the message on undefined value. This behavior can be changed by providing default value.

```md
{{CONTACT `subscriber_name` `My friend`}}
```
::: tip
Tokens `campaign_id`, `message_id`, and `subscriber_id` return the same `IDs` as in API. For example you can
pass `subscriber_id` token in [links](links.md):
:::

```md
{{LINK `http://myshop.com/index.html?visitor={{CONTACT `subscriber_id`}}`}}
```

After receiving click on your server use this `ID` to get additional info about visitor from API
using [getContactById](https://apireference.getresponse.com/#operation/getContactById).

---

# Conditions

Allows to display various parts of message depending on **campaign or contact or message\_info**, **contact custom fields or tags**, **contact geo location** or **dates**.

```md
{{IF `(pet IS_DEFINED)`}}
    {{IF `(pet STRING_EQ 'dog')`}}
        Buy a bone for your dog! {{LINK `http://mysite.com/shop/product/bone_for_dog`}}
    {{ELSIF `(pet STRING_EQ 'cat')`}}
        Buy a mouse toy for your cat! {{LINK `http://mysite.com/shop/product/toy_mouse_for_cat`}}
    {{ELSE}}
        You may find something for your pet in my store!
    {{ENDIF}}
{{ELSE}}
    You don't have a pet yet. Buy one!
{{ENDIF}}

{{IF `((city STRING_EQI 'Gdańsk') LOGIC_OR ((city STRING_EQI 'Gdynia') LOGIC_OR (city STRING_EQI 'Sopot')))`}}
    You can visit our store located in 3City in person!
{{ELSE}}
    Go to our online page: {{LINK `http://mysite.com/shop`}}
{{ENDIF}}

{{IF `(day_name STRING_NEQ 'Sunday')`}}
    We're open today.
{{ELSE}}
    Please visit us from Monday to Saturday
{{ENDIF}}
```

Order of tags:

*   ```{{IF `...`}}``` – Mandatory beginning of conditional statement.
*   ```{{ELSIF `...`}}``` – Optional block, multiple allowed.
*   ```{{ELSE}}``` – Optional default block, one allowed.
*   ```{{ENDIF}}``` – Mandatory closing of conditional statement.

Building conditions step by step:

*   Take left operand, this can be name of **contact custom field or tag** or token from **campaign or contact or message\_info**, **contact geo location**, **dates**.

    ```md
    DAY
    ```

*   Lowercase this operand.

    ```md
    day
    ```

*   Take right operand which is constant value you like left operand to be compared against.

    ```md
    8
    ```

*   Quote this operand in single quotes, this is mandatory even if operand is numeric.

    ```md
    '8'
    ```

*   Join operands with operator.

    ```md
    day NUMBER_GT '8'
    ```

*   Wrap this pair in round brackets to get conditional statement.

    ```md
    (day NUMBER_GT '8')
    ```

*   (optional) If you need more complex logic you can join conditional statements with logic operator. Remember about top round brackets to create conditional statement.

    ```md
    ((day NUMBER_GT '8') LOGIC_AND (day NUMBER_LT '16'))
    ```

*   Use conditional statement in tag param.

```md
{{IF `((day NUMBER_GT '8') LOGIC_AND (day NUMBER_LT '16'))`}}
You will see this if message was sent between 8th and 16th day of month.
{{ENDIF}}
```

Operators:

*   `NUMBER_LT` – Less than.
*   `NUMBER_GT` – Greater than.
*   `NUMBER_EQ` – Equal.
*   `NUMBER_NEQ` – Not equal.
*   `NUMBER_GEQ` – Greater or equal.
*   `NUMBER_LEQ` – Less or equal.
*   `NUMBER_DIV` - True if divisable by given value.
*   `STRING_EQ` – Equal.
*   `STRING_EQI` – Equal but case-insensitive.
*   `STRING_NEQ` – Not equal.
*   `STRING_NEQI` – Not equal case-insensitive.
*   `STRING_CO` – Contains.
*   `STRING_COI` – Contains but case-insensitive.
*   `STRING_NCO` – Not contains.
*   `STRING_NCOI` – Not contains case-insensitive.
*   `DATE_IS_ANNIVERSARY` - True during anniversary of operand (check notes below for details). Only left operand is required - `(subscriber_created_at DATE_IS_ANNIVERSARY)`.
*   `DATE_IS_MENSIVERSARY` - True during mensiversary of operand. Only left operand is required - `(revewal_started_at DATE_IS_MENSIVERSARY)`.
*   `LOGIC_OR` – Union used if A and B are conditions.
*   `LOGIC_AND` – Intersection used if A and B are conditions.
*   `IS_DEFINED` – Check for value presence. Only left operand is required - `(car IS_DEFINED)`.
*   `NOT_DEFINED` – Check for value absence. Only left operand is required - `(car NOT_DEFINED)`.

::: warning
If you use `(pet STRING_EQ 'dog')` and contact custom field pet is not defined then the statement will evaluate to false. In most cases this is what you mean, but it is better to use additional
`IS_DEFINED` operator to keep logic clean.
:::

::: warning
If you apply `NUMBER_*` operator to not numeric value it will evaluate to false.
:::

::: warning
If custom field in condition is multi value then conditional statement will evaluate to true if any element matches it. 
So if custom pet has values "mouse" and "hamster" then 
`(pet STRING_EQ 'mouse')` is true because "mouse" value meets the condition, but also
`(pet STRING_NEQ 'mouse')` is true because "hamster" value meets the condition.
:::

## Mangling

Mangling allows you to use **contact custom field name or tag name or token name** as left operand without having to worry about its tag type. For example if you use `(city STRING_EQI 'Gdańsk')` then:

1.  Value of contact custom field city is checked. If it exists conditional statement is resolved to true or false at this stage.
2.  City is also token in contact geo location. If it exists and conditional statement is not yet resolved then conditional statement is resolved to true or false at this stage.
3.  Conditional statement is false if not yet resolved.

Presence of custom/tags of given name is always checked before presence of such named token in other tags. Do not nest whole tags, for example  ```{{IF `{{CUSTOM `pet`}} STRING_EQ 'dog'`}}``` is not correct syntax.

## Anniversary/mensiversary notes

* **Month length differences**: If day in operand does not exist in current month anniversary / mensiversary happens on last day of current month. For example someone who subscribed on `2026-01-31` has mensiversary on `2026-04-30` (April does not have 31 days). Someone who subscribed on `2024-02-29` (leap year) has anniversary / mensiversary on `2026-02-28` (February in non-leap year does not have 29 days).
* **Time zones**: GeoIP time zone is used if known. Otherwise user timezone set in GetResponse account is used. For example someone from Poland who subscribed at `2024-01-21 10:00:00 UTC` with known GeoIP of `Europe/Warsaw` (so subscription time from his perspective is `2024-01-21 11:00:00 Europe/Warsaw`) has example mensiversary on `2024-02-21 Europe/Warsaw` (`2024-01-20 23:00:00` - `2024-01-21 23:00:00` UTC). So feature respects calendar day boundaries from recipient perspective. **Warning**: Custom field values do not carry time zone information and are assumed to be in UTC for this conversion. Do not store custom field values recalculated to your local time or double conversion will happen.

---

# Contact

## Contact custom fields

Merge-words for contact custom (additional) fields.

```md
{{CUSTOM `car`}}
``` 

[Prettifiers](http://apidocs.getresponse.com/v3/dynamic-content/prettifiers) are allowed.

Contact custom fields can be defined on [GetResponse WWW](https://app.getresponse.com/custom_fields_list.html "GetResponse WWW") or by GetResponse API. Empty string is inserted into the message on undefined value. This behavior can be changed by providing default value.

```md
{{CUSTOM `car` `your car`}}
```

Contact tags
------------

Merge-words for contact tags.

```md
{{TAG `responsive`}}
```

Tags can be defined by [GetResponse API](../resources/tags.md). Empty string is inserted into the message on undefined value. This merge-word is especially useful in [conditions](conditions.md).

Contact geo location
--------------------

Geo location info based on contact IP (if available).

```md
{{GEO `country`}}
``` 

Supported tokens:

*   `latitude`
*   `longitude`
*   `country_code`
*   `country`
*   `city`
*   `region`
*   `postal_code`
*   `dma_code`
*   `continent_code`
*   `time_zone` - Given as name, not as offset. For example "Europe/Warsaw".

[Prettifiers](http://apidocs.getresponse.com/v3/dynamic-content/prettifiers) are allowed.

Empty string is inserted into the message on undefined value. This behavior can be changed by providing default value.

```md
{{GEO `city` `Your city`}}
```

Contact subscription date
-------------------------

Contact subscription date that can be presented in various formats.

```md
{{ADDED_ON `you subscribed on DAY_ORDINATED of MONTH_NAME, it was DAY_NAME`}}
``` 

(will insert "you subscribed on 11th of July, it was Friday")

Format part can contain special tokens (uppercased!) that will be replaced with date parts.

*   `CENTURY` – For example "21".
*   `YEAR` – For example "2012".
*   `YEAR_SHORT` – For example "10".
*   `MONTH` – From "01" to "12".
*   `MONTH_NAME` – From "January" to "December".
*   `MONTH_NAME_SHORT` – From "Jan" to "Dec".
*   `DAY` – From "01" to "31".
*   `DAY_NAME` – From "Monday" to "Sunday".
*   `DAY_NAME_SHORT` – From "Mon" to "Sun".
*   `HOUR` – From "00" to "23".
*   `MINUTE` – From "00" to "59".
*   `SECOND` – From "00" to "59".

Format can also contain every other character except double quotes and back-tick to format date.

::: tip
You can get rid of leading zeroes by suffixing numeric token with `_NONZERO`.
:::

*   `HOUR_NONZERO` – From "0" to "23".

::: tip 
You can ordinate numeric token value by suffixing it with `_ORDINATED`.
:::

*   `DAY_ORDINATED` – From "1st", "2nd", "3rd" to "31st".

Ordinated values are always stripped of leading zeros.

::: warning
You cannot use `_NONZERO` or `_ORDINATED` with naming tokens like `DAY_NAME`.
:::

::: tip
Date is presented in contact time zone. If it is not known then user time zone is used.
:::

---

# Dates

## Dates

Date of email delivery that can be presented in various formats and be time-shifted.

```md
{{DATE `this email was sent on DAY_ORDINATED of MONTH_NAME, it was DAY_NAME`}}
``` 

(will insert "this email was sent on 11th of July, it was Friday")

Format part can contain special tokens (uppercased!) that will be replaced with date parts.

*   `CENTURY` – For example "21".
*   `YEAR` – For example "2012".
*   `YEAR_SHORT` – For example "10".
*   `MONTH` – From "01" to "12".
*   `MONTH_NAME` – From "January" to "December".
*   `MONTH_NAME_SHORT` – From "Jan" to "Dec".
*   `DAY` – From "01" to "31".
*   `DAY_NAME` – From "Monday" to "Sunday".
*   `DAY_NAME_SHORT` – From "Mon" to "Sun".
*   `HOUR` – From "00" to "23".
*   `MINUTE` – From "00" to "59".
*   `SECOND` – From "00" to "59".

Format can also contain every other character except double quotes and back-tick to format date.

::: tip
You can get rid of leading zeroes by suffixing numeric token with `_NONZERO`.
:::

*   `HOUR_NONZERO` – From "0" to "23".

::: tip
You can ordinate numeric token value by suffixing it with `_ORDINATED`.
:::

*   `DAY_ORDINATED` – From "1st", "2nd", "3rd" to "31st".

Ordinated values are always stripped of leading zeros.

::: warning
You cannot use `_NONZERO` or `_ORDINATED` with naming tokens like `DAY_NAME`.
:::

::: tip
Date supports time-shift.
:::

```md
{{DATE `YEAR-MONTH-DAY` `+10 DAY`}}
``` 

Offset must be given as "+" or "-" sign, value of time shift and unit of time shift. Allowed units are.

*   `YEAR`(`S`) – 365 days.
*   `MONTH`(`S`) – 30 days.
*   `DAY`(`S`)
*   `HOUR`(`S`)

Total amount of time shift cannot exceed +/-16 years. If it does then unmodified date will be inserted into a message.

::: tip
Date is presented in contact time zone. If it is not known then user time zone is used.
:::

## Timers

::: warning
**This function is deprecated and will be removed on 2021-05-01.**
:::
Countdown to/since given timestamp or contact subscription date.

```md
{{TIMER `2012-12-21 00:00:00` `DAYS_UNIT HOURS_UNIT to the end of the world` `World ended DAYS days ago`}}
``` 

(will insert "291 days 7 hours to the end of the world" at the moment this doc was created and will insert "World ended 32 days ago" when it is 32 days after the timestamp date)

```md
{{TIMER `added_on` `` `You signed up DAYS_UNIT ago`}}
```

(will insert "You signed up 35 days ago")

First param is timestamp that can be provided as:

*   Date and time - "YYYY-MM-DD HH:MM:SS" - must be in UTC time zone.
*   Date - "YYYY-MM-DD" - must be in UTC time zone.
*   Contact subscription date - "added\_on"

Second / third params (both are mandatory, even if empty) are future / past formats. They are displayed if the message was sent before / after given timestamp. Those formats can contain special tokens that will be replaces with amounts of those units.

*   `CENTURIES`
*   `YEARS` - 365 days.
*   `MONTHS` – 30 days.
*   `DAYS`
*   `HOURS`
*   `MINUTES`
*   `SECONDS`

::: tip
If you want unit name along with numeric value suffix token with `_UNIT`, for example:
:::

```md
{{TIMER `2010-01-01 00:00:00` `HOURS_UNIT` ``}}
``` 

(will insert "8 hours")

::: tip
Tokens are greedy. It means that you do not have to use all of them in formats. Tokens you use can "consume" amount of time in a smart way.
:::

```md
{{TIMER `2010-01-01 00:00:00` `HOURS_UNIT` ``}}
``` 

(will insert "49 hours")

```md
{{TIMER `2001-01-01 00:00:00` `DAYS_UNIT and HOURS_UNIT` ``}}
```

(will insert "2 days and 1 hour" because `DAYS` token "consumed" 48 hours)

---

# External Content

::: warning
External Content and External Lexpad are complementary features but they serve very different purposes. Please read **both** documentations very carefully and then choose the right solution for your task. Otherwise you may fall into inefficient design antipatterns that will affect sending speed and may generate excessive network traffic.

You should use **External Content** when you want to **include paragraphs that depend on some limited set of variables**.
:::
## Synopsis

Let's assume you have real estate business and you want to present "offer of the day" in your messages.

Of course you want to avoid editing your messages on daily basis and you want to personalize this offer for contacts.

To do so include following tag in your message:

```md
{{EXTERNAL `http://example.com/index.html?location={{GEO `city`}}&type={{CUSTOM `interested_in`}}&`}}
``` 

When message is sent:

1.  Link is evaluated. For example contact is from `"city"` Chicago and you stored his preferences in multivalue custom `"interested_in"`, then target link will be `http://example.com/index.html?location=Chicago&type=condominiums,duplexes&`.
2.  External content is downloaded from this link. Your server should return content correlated with passed params.
3.  Content in placed in message instead of tag.

And each of your contact will automatically get offer of the day matching their location and interests.

## General rules

*   Your server must respond within 4 seconds.
*   Your server must be capable of handling up to 100 concurrent requests.
*   Response cannot be larger than 64KB per one tag.
*   Returned content must be UTF-8 encoded.
*   Returned content must have valid Dynamic Content syntax.

**If any of rules above are broken then message will be sent to contact, but  evaluated URL will be inserted into the message in place of EXTERNAL tag.**

## Don't!

*   Use External Content unique per contact. For example by using ```{{CONTACT `subscriber_id`}}``` tag as link parameter or some customs that are unique per contact (like phone number). This will be painfully slow. If you want to do so then you probably need [External Lexpad](external-lexpad.md).
*   Format data structures on your side. For example if you want to return "top 20 real estate offers in your location" then you probably need [External Lexpad](external-lexpad.md).
*   Return whole www pages from your server (with headers, CSS styles, scripts, and so on). This probably will not work because of broken message structure and limited capabilities of email clients. Your server should only return piece of content that you want in this part of message. As much formatting as possible should remain in static message content.

**If we notice high ratio of different URLs compared to amount of sent messages (content is very contact-specific) or inefficient flow we may block this feature until those issues are resolved.**

## Advanced stuff

### Link params

External Content URL can be parametrized link with [campaign predefined values](campaign.md), [contact custom field](contact.md), [campaign or contact or message info](campaign.md) or [contact geo location](contact.md) tags inside URL. Just nest corresponding tags in your external link.

Nested tags have following restrictions:

*   Can not contain default value - ```{{CONTACT `subscriber_name` `Friend`}}``` is forbidden.
*   Can not use [prettifiers](prettifiers.md) - ```{{CONTACT `uc(subscriber_name)`}}``` is forbidden.
*   Are encoded in UTF-8 as URL param, so if ```{{CONTACT `subscriber_name`}}``` is `"Pabian Paweł"` it will be inserted into link as `"Pabian%20Pawe%C5%82"` to make link valid. Please note that `"/"` character will also be encoded as `"%2F"` so do not use nested tag as part of your link path.

### Nested tags

You can use every Dynamic Content tag in content returned from your server.

For external ```{{EXTERNAL `http://example.com/about_us` }}``` your server can return

```md
Hi {{CONTACT `ucfw(subscriber_first_name)`}}! We are international company. {{LINK `http://company.com`}} 
```

This response will be re-evaluated (including click tracking), so following content will be inserted into the message.

```md
Hi Paweł! We are international company. http://getresponse.com/click.html?x=a62a&.. 
```

### Multiple externals

You can include many external tags in single message.

```md
Hi This is what you may need for your pet {{EXTERNAL `http://pet.store.com/?animal={{CUSTOM `pet`}}&limit=1`}} And you may check our other products {{EXTERNAL `http://pet.store.com/general_offer`}}
```

### Reentrance

Yes, it is possible to use External Content inside another External Content. Moreover, sometimes it is recommended to achieve better message structure and reduce network traffic. For example:

```md
{{EXTERNAL `http://example.com/product?id=123`}}
```

May return:

```md
Hammer drill Neighborex-2000XT  
Buy now and you will get bonus:    
{{EXTERNAL `http://example.com/product?id=456`}}
```
Where inner external may return:
`
Set of 30 cemented carbide drills.  
Diameters: 32mm, 30mm, 25mm, ...
`

This way you won't have to resend the same bonus product content over and over again with each base product purchased.

And if inner product is used frequently it will benefit from content caching (see below).

### Caching

Fetched content is cached per URL basis. And this cache will be reused every time the same URL is spotted, even if it is in different message.

That allows to reduce network traffic, but may be tricky if you updated returned content under given URL and want it to be fetched again before new message is sent. To force refresh you can add dummy param and ignore it on the server side.:

```md
{{EXTERNAL `http://example.com/greeting?message={{CONTACT `message_id`}}`}}
```

This way URL will be different in every message and cache will not be used.

### Content types

Be aware of message content type. If you send dual (plain and HTML) messages your external content source should also be able to return plain and HTML. For example use in plain part of the message ```{{EXTERNAL `http://about.me/main?type=plain"}}``` and in HTML part of the message use ```{{EXTERNAL `http://about.me/main?type=html`}}``` and serve different content from your server depending on type param value.

### Authorization

If you want to prevent reading external content from other places than GetResponse you can use additional param that will be passed as `X-Auth-Token` header in HTTP request.

```md
{{EXTERNAL `https://example.com/secret_stuff` `400aad99cd7f1191451adb226ba40349`}}
```

Token will be as safe as message content itself (so for example don't use external with authorization inside external without it) and transmission between GetResponse and your server (use HTTPS).

---

# External Lexpad

::: warning
External Content and External Lexpad are complementary features but they serve very different purposes. Please read **both** documentations very carefully and then choose the right solution for your task. Otherwise you may fall into inefficient design antipatterns that will affect sending speed and may generate excessive network traffic.
You should use **External Lexpad** when you want to **populate message content using complex data structures that are specific for every recipient**.
:::

## Availability

Currently this feature is only available for messages defined through [API](https://apireference.getresponse.com) (excluding RSSes).

To use it provide `sendSettings` → `externalLexpad` section in API call such as [createNewsletter](https://apireference.getresponse.com/#operation/createNewsletter).

## Synopsis

Let's assume that you have online book store.

Every customer in this store:

*   Has corresponding contact in GetResponse (for example you synchronize them using [API](https://apireference.getresponse.com)).
*   Can choose favorite book categories.

Now you want to send message to your contacts containing section with new books in their categories.

At this point you should notice few things:

*   You will apply the same formatting for many elements (books) in array.
*   Every element (book) will have many attributes (author, title, cover type, tags, and so on).
*   Set of those elements (books) will be quite unique for every customer. For example if there are 16 categories in your store then there are 65536 sets of favorite categories possible.

That is the sign, that you should use **External Lexpad**, not External Content

### WebService

First you have to provide endpoint, that will return data structure with new books for every GR contact.

Let's assume it is located at: `https://example.com/new_books.json`

Communication in both ways uses JSON and your service will get following **POST** request:
```json
{
  "campaign": {
    "id": "ABC123"
  },
  "message": {
    "id": "QWE123"
  },
  "subscriber": {
    "id": "RTY456"
  }
}
```

IDs in query are the same as returned by [API](https://apireference.getresponse.com). Please note that "contact" is called a "subscriber" in request due to backward compatibility.

The authorization token that you've passed in API call will be sent back in `X-Auth-Token` header and **must be checked by your endpoint**.

Now your webservice should find corresponding customer in book store, check which categories are marked by this customer as favorite, find list of new books in those categories and return them in JSON data structure of your choice:
```json
{
  "month": "May",
  "new_books": {
    "Science-fiction": [
      {
        "title": "Attack from Mars",
        "author": "John Foo"
      },
      {
        "title": "Robots",
        "author": "Anna Bar"
      }
    ],
    "Horror": [
      {
        "title": "Dark forest",
        "author": "Peter Baz"
      }
    ]
  }
}
```


This structure is called "Lexpad" and serves the same purpose as lexpads in programming languages - provides data for code execution.

### Message

Message content can use special mergewords that allows to iterate over provided data structure.
```md
Hi {{CONTACT `subscriber_first_name`}}  

Check out new books released in {{TOPIC `month`}} that may interest you:  

{{LOOP `new_books` `category` `books`}}  
    In category {{TOPIC `category`}} we have  
    {{LOOP `books` `book`}}  
        - {{TOPIC `book` `title`}} written by {{TOPIC `book` `author`}}  
    {{ENDLOOP}}  
{{ENDLOOP}}  

Happy reading!
```

### Result

Before message is sent to subscriber GetResponse will send Lexpad request to your webservice and will use received data to execute mergeword logic, producing following message:
```md
Hi Tom  

Check out new books released in May that may interest you:  

    In category Science-fiction we have  
        - Attack from Mars written by John Foo  
        - Robots written by Anna Bar  
    In category Horror we have  
        - Dark forest written by Peter Baz  

Happy reading!  
```

As you can see External Lexpad feature allows to use more sophisticated template logic. And while most Dynamic Content tags operate on data stored in GetResponse (for example contact name) for `LOOP` tags you provide data yourself through your webservice. Simple? OK, let's dig into details :)

General rules
-------------

*   WebService must respond within 4 seconds.
*   Response cannot be larger than 32KB.
*   Lexpad must be in JSON format using UTF-8 character set.
*   Top level structure must be JSON object. Arrays or bare values are not allowed.

**If any of rules above are broken then message won't be sent to contact**.

*   It is strictly forbidden to use any formatting directives in Lexpad. Values within must never contain any HTML tags, CSS styles, newlines, etc. Whole formatting must be done on message content level exclusively to speed up sending process and minimize lexpad size and network traffic. It may be tempting to return whole piece of text preformated on webservice side without learning those `LOOP` and `TOPIC` constructs, but any detected attempt to do so will result in **immediate block of this feature**. Preformatting on server side would mean pushing over network the same formatting directives again and again, which is very inefficient and therefore we do not allow it.
*   It is strictly forbidden to clicktrack links personalized in LexPad per subscriber. This causes separate clicktrack entries per every link and will immediaterly clog message statistics. See "Clicktracking" section for more details.
*   It is recommended to return JSON in compact form, without pretty formatting.
*   We do not enforce how data structure inside top JSON object should look like. Dynamic Content mergeword execution is fast. Like **really, really, really fast**. So if your data has deep strucure by its nature do not be afraid to use many levels of nested `LOOP`s to format the output.

TOPIC tag
---------

This tag prints value available in current scope under given name (first param). It understands Scalars, Arrays and Hashes.

Lexpad:
```json
{
  "greeting": "Hello",
  "subject": [
    "Dog",
    "World",
    "Kitty"
  ],
  "punctuation": {
    "dot": ".",
    "exclamation": "!",
    "question": "?"
  }
}
```

Message:

```md
{{TOPIC `greeting`}} {{TOPIC `subject` `1`}} {{TOPIC `punctuation` `exclamation`}}
```

Result:

`Hello World !`

Explanation:

*   First param is value name.
*   Second param is not present for Scalar values, it is numeric for Array values and it is string for Hash values.
*   Accessing value in a way which do not corresponds with its type will not print such value. For example ```{{TOPIC `greeting` `foo`}}``` will be skipped because value under ``greeting`` key is a Scalar, not a Hash. The same applies to ```{{TOPIC `subject`}}```, which is an Array and expects index to be given.
*   Arrays are enumerated from `0`. Index is numeric but still must be quoted like any other param according to general Dynamic Content rules.
*   Arrays can only be indexed in positive, integer, ASCII-only numbers. There are no tricks like counting backwards using negative index, known from some programming languages.
*   It is impossible to use numbers as hash keys.
*   You can not traverse into nested lexpad ```{ `foo` : { `bar` : { `baz` : 123 } } }``` using single mergeword like ```{{TOPIC `foo` `bar` `baz`}}```. To access deeper values `LOOP` must be used.

LOOP tag
--------

This tag iterates over Hash and Array structures and binds values to new names.

### Iterating over Array

Lexpad:
```json
{
  "cars" : [ `Dodge`, `Uaz`, `Fiat` ]
}
```

Message:
```md
{{LOOP `cars` `car`}}  
    {{TOPIC `car`}}  
{{ENDLOOP}}
```

Result:
```md
Dodge  
Uaz  
Fiat
```

Explanation:

*   First param is value name.
*   Value is expected to be an Array. Otherwise whole `LOOP` will be skipped.
*   Second param describes new name that values within Array will be bound to. This `"car"` name will be available for `TOPIC`s, `IF`s or nested `LOOP`s within this `LOOP` scope (continue reading to encounter those mythical creatures).

### Iterating over Hash

Lexpad:
```json
{
  "sounds": {
    "cat": "meow",
    "pig": "oink",
    "dog": "woof"
  }
}
```

Message:

```md
{{LOOP `sounds` `pet` `does`}}  
    {{TOPIC `pet`}} - {{TOPIC `does`}}  
{{ENDLOOP}}
```

Result:
```md
cat - meow  
dog - woof  
pig - oink
```

Explanation:

*   First param is value name.
*   Value is expected to be a Hash. Otherwise whole `LOOP` will be skipped.
*   Second and third param describe new key and value name that values within Hash will be bound to. Those values are available for `TOPIC`s, `IF`s or nested `LOOP`s within this `LOOP` scope.
*   Hashes are unordered by nature, therefore order from your JSON file will not be preserved. Iteration will go over keys sorted lexicographically.

Advanced stuff
--------------

Let's assume you have diet business and you are sending daily diet for each contact. We'll use the same lexpad for next few cases:

Lexpad:
```json
{
  "diet": {
    "Breakfast": {
      "Eggs": {
        "preparation": "boiled",
        "amount": "2",
        "nutrition": {
          "fat": "25g",
          "proteins": "26g",
          "carbs": "4g"
        },
        "recipe": "https://example.com/boiled_eggs.html"
      }
    },
    "Dinner": {
      "Beef": {
        "preparation": "grilled",
        "amount": "100g",
        "nutrition": {
          "proteins": "30g",
          "fat": "10g"
        },
        "recipe": "https://example.com/grilled_burger.html"
      },
      "Potatoes": {
        "preparation": "boiled",
        "amount": "100g",
        "nutrition": {
          "proteins": "2g",
          "fat": "1g",
          "carbs": "20g"
        },
        "recipe": "https://example.com/boiled_potatoes.html"
      }
    }
  }
}
```
    

### Nested iteration

It was already shown in Synopsis, but now let's go through the details:

```md
{{LOOP `diet` `meal` `ingredients`}}
    ...  
{{ENDLOOP}}
```

This will bind keys in `"diet"` Hash to `"meal"` name. So `"meal"` will be `"Breakfest"` and "`Dinner"`. Values in `"diet"` hash will be bound to `"ingredients"` name and they contain Hash. So to display every ingredient in every meal you have to iterate over `"ingredients"`.

```md
{{LOOP `diet` `meal` `ingredients`}}
    {{LOOP `ingredients` `ingredient_name` `ingredient_attributes`}}
        ...
    {{ENDLOOP}}
{{ENDLOOP}}
```

You can go as deeply as needed, just be aware of data type (Hash or Array) you are iterating on.

### Binding scopes

Now that we have base iteration let's print something useful:
```md
{{LOOP `diet` `meal` `ingredients`}}
    For {{TOPIC `meal`}} prepare:
    {{LOOP `ingredients` `ingredient_name` `ingredient_attributes`}}
        - {{TOPIC `ingredient_attributes` `amount`}} {{TOPIC `ingredient_attributes` `preparation`}} {{TOPIC `ingredient_name`}}
        Enjoy {{TOPIC `meal`}}!
    {{ENDLOOP}}
{{ENDLOOP}}
```

Which will print:
```md
For Breakfast prepare:  
    - 2 boiled Eggs  
    Enjoy Breakfast!  
For Dinner prepare:  
    - 100g grilled Beef  
    - 100g boiled Potatoes  
    Enjoy Dinner!
```

In this example you can see, that:

*   `TOPIC` behaves exactly the same way, doesn't matter how deep in `LOOP` structures it is burried. If `"ingredient_attributes"` in inner most loop is a Hash then you can get value under `"amount"` key by using ```{{TOPIC `ingredient_attributes` `amount`}}```.
*   Each name assigned in `LOOP` is also available in sub`LOOP`s. That's why it is possible to use ```Enjoy {{TOPIC `meal}}``` in inner most loop, while `"meal"` was bound in outer loop.

### Re-binding scopes

You can rebind name in inner LOOP.
```md
{{LOOP `diet` `name` `ingredients`}}  
    {{LOOP `ingredients` `name` `attributes`}}  
    {{ENDLOOP}}  
{{ENDLOOP}}
```

Try to **avoid it** unless you know what you are doing. In this case for example you won't be able to use ```Enjoy {{TOPIC `name`}}``` part, because ingredient name in inner `LOOP` scope masks meal name from outer `LOOP`.

### Clicktracking

Any value reachable through `TOPIC` tag can be used as URL in `LINK` tag.
```md
{{LOOP `diet` `meal` `ingredients`}}
    {{TOPIC `meal`}}:
    {{LOOP `ingredients` `ingredient` `ingredient_attributes`}}
        - {{TOPIC `ingredient`}}
            Recipe {{LINK `ingredient_attributes` `recipe`}}
    {{ENDLOOP}}
{{ENDLOOP}}
```

This will print:
```md
Breakfast:
    - Eggs
        Recipe http://getresponse.com/click.html?...
Dinner:
    - Beef
        Recipe http://getresponse.com/click.html?...
    - Potatoes
        Recipe http://getresponse.com/click.html?...
```


And all those links will be visible under message statistics.

Explanation:

*   Way of accessing values is exactly the same as for `TOPIC` tag. First param is value name. Second param is not present for Scalar values, it is numeric for Array values and it is string for Hash values.
*   You cannot give custom names to links clicktracked from Lexpad, second param is used exclusively for Lexpad indexing.

Limitations:

*   Length of clicktracked link is limited to 2048 characters.
*   Clictracking does not interpret Dynamic Content inside link, it is not possible to provide through LexPad links like ```http://example.com?email={{CONTACT `subscriber_email`}}```.
*   Links must not be unique per subscriber. Due to limitation described above it may be tempting to compose links per subscriber like `http://example.com?email=foo@example.com` and pass them in LexPad. However it will cause multiple subscriber-specific links appear in message statistics, each one will be clicktracked individually for single subscriber. This will severly impact statistics performance and is not allowed.

### Conditions

Any Scalar value reachable through `TOPIC` tag can be used as left value in `IF` tag.
```md
{{LOOP `diet` `meal` `ingredients`}}
    {{TOPIC `meal`}}:
    {{IF `(meal STRING_EQ 'Dinner')`}}
        Eat before 17:00
    {{ENDIF}}
    {{LOOP `ingredients` `ingredient` `ingredient_attributes`}}
        - {{TOPIC `ingredient_attributes` `preparation`}} {{TOPIC `ingredient`}}
        {{LOOP `ingredient_attributes` `ingredient_attribute_name` `ingredient_attribute_value`}}
            {{IF `((ingredient_attribute_name STRING_EQ 'preparation') LOGIC_AND (ingredient_attribute_value STRING_EQ 'grilled'))`}}
                Don't burn it!
            {{ENDIF}}
        {{ENDLOOP}}
    {{ENDLOOP}}
{{ENDLOOP}}
```

This will print:
```md
Breakfast:
        - boiled Eggs
    Dinner:
        Eat before 17:00
        - grilled Beef
            Don't burn it!
        - boiled Potatoes
```

Explanation:

*   Left side of condition is value name and it always mean Scalar reference. More on that later.
*   Lexpad has precedence over custom values - ```{{IF `(car ...)`}}``` will take value from Lexpad first and fallback to value from custom if Lexpad one is not present. Use distinctive names for your Lexpad keys to avoid confusion!

One shortcoming that you've probably noticed is that `IF` works only on Scalar values and cannot reach into Hashes or Arrays like `TOPIC` can. So `"meal"` is Scalar value, accessible in this scope through ```{{TOPIC `meal`}}``` and also usable in condition directly through ```{{IF `(meal ...)`}}```. However making condition on `"preparation"` method is slightly more complicated. It can be easilly printed by ```{{TOPIC `ingredient_attributes` `preparation`}}``` but condition cannot use the same syntax and left value must be bound as Scalar. You have to make another `LOOP`, inside which `"ingredient_attribute_name"` and `"ingredient_attribute_value"` will be Scalars. Then you should filter out keys which you are not interested in using `(ingredient_attribute_name STRING_EQ 'preparation')` portion of the `IF` and then compare value in `"ingredient_attribute_value"`. If you run into this issue then the best way out is to rethink Lexpad layout and provide data in more direct or de-normalized way.

---

# Links

## Clicktracked links

Mark links for click counting tracking and assign optional description for statistics.

```md
{{LINK `http://mysite.com`}}
``` 

For messages composed on [GetResponse WWW](https://app.getresponse.com/choose_html_or_plain.html?msg_type=broadcast "GetResponse WWW") editor all links are marked for tracking automatically and tracking takes place if "Track click-through's of your links" on editor window is chosen.

For messages sent using GetResponse API links must be wrapped in `{{LINK}}` tag on clients side to mark it for tracking. Also

`"flag"  : [ "clicktrack" ]`

must be passed to method.

::: warning
Tracking is not the same as wrapping links in HTML tags. To make tracked link clickable in HTML you still need to use anchor.
:::

```md
<a href="{{LINK `http://mysite.com`}}">My site</a>
```

Note that you can use back-ticks instead of double quotes and remove white spaces to avoid trouble with HTML editors.

::: tip
You can use campaign predefined values, campaign or contact or message_info, contact custom fields or contact geo location tags inside your URL.
:::

```md
{{LINK `http://mysite.com/login?email={{CONTACT `subscriber_email`}}&from_where={{GEO `city`}}`}}
```

Nested tags have following restrictions:

*   Can not contain default value - ```{{CONTACT `subscriber_name` `Friend`}}``` is forbidden.
*   Can not use prettifiers - ```{{CONTACT `uc(subscriber_name)`}}``` is forbidden.
*   Are encoded in UTF-8 as as URL param, so if ```{{CONTACT `subscriber_name`}}``` is "Pabian Paweł" it will be inserted into link as "Pabian%20Pawe%C5%82" to make link valid. Please note that "/" character will also be encoded as "%2F" so do not use nested tag as part of your link path.
*   You cannot create nested date tag in links.

::: tip
You can give links a custom description.
:::

```md
{{LINK `http://mysite.com` `My site`}} 
```

If description is given link is shown under this name instead of URL on performance stats. It makes stats easier to read and allows to do two tricks – splitting and merging. Splitting allows to show many links with the same URL under different names. It may be useful for statistical purposes like creating a "click heat map" of your message.

```md
Hello {{LINK `http://mysite.com` `My page at the beginning of the message`}} Some message body {{LINK `http://mysite.com` `My page at the end of the message`}} Sincerely 
```

Now you know which link was clicked more often because - despite common URL - those links will be shown under separate names on performance stats. Merging is opposite to splitting – many links with different URLs will be shown under one name on performance stats. This is helpful if you do not need to distinguish them.

```md
{{LINK `http://mysite.com/shop/main` `Main shop page`}} {{LINK `http://myoldsite.com/redirect/shop` `Main shop page`}}
``` 

System links
------------

Links that allow contact to perform actions.

```md
{{LINK `me`}} 
```

Supported tokens and message types they can be used in:

*   `me` (newsletter, autoresponder, rss) – Manage subscription and details. This is the same link as in footer.
*   `change_details` (newsletter, autoresponder, rss) – Manage contact details. This is the same link as in footer.
*   `unsubscribe` (newsletter, autoresponder, rss) – Unsubscribe link. This is the same link as in footer.
*   `view` (newsletter, autoresponder, rss) – View message on website. May be useful if contact is using email client that blocks content, for example images.
*   `confirm` (confirmation) - Confirm subscription in double optin mode.

Social links
------------

Links that allow contact to share info about message on social media.

```md
{{LINK `social_digg`}} 
```

Allowed tokens:

*   `social_digg`
*   `social_facebook`
*   `social_googleplus`
*   `social_linkedin`
*   `social_myspace`
*   `social_twitter`

::: warning
If you want your newsletter to be shared on social media you must select "Publish in RSS" on last step of creating newsletter process in old editor.
:::

---

# Prettifiers

Several functions are allowed in some tags:

*   `lc()` – Lowercase all characters. `ComPUTer` will be inserted into message as `computer`.
*   `uc()` – Uppercase all characters. `coMPuTEr` will be inserted into message as `COMPUTER`.
*   `ucfw()` – Uppercase first letters in each word and lowercase other. `o'reilly bOOk PUBLISHING` will be inserted into message as `O'Reilly Book Publishing`. Note that this beautifulizer also recognizes parts that should not be uppercased. `Ludwig VAN beethoven Jr` will be inserted as `Ludwig van Beethoven jr`. Current list of exceptions consists of: von, van, bin, ibn, mgr, dr, prof, imc, jr and may be extended if needed.
*   `ucfs()` – Uppercase first letter of every sentence and lowercase other letters. `how ARE you? i'm FINE.` will be inserted into message as `How are you? I'm fine.`.
*   `md5()`, `sha1()`, `sha256()` - Calculate hash function from given value.
*   `escape_html()` - You should always use this one if you print subscriber data (like custom or name) directly in HTML messages to avoid accidental HTML breaks and XSS injections.
*   `escape_url_param()` - Useful when you need to use some data as URL param to avoid breaking URL structure. You should NOT use it if URL is inside LINK tag because then values are escaped automatically.

For polish users declensions are available for names.

*   `vocative()` – Create vocative form of name, Tomek will be inserted into message as Tomku. Currently Polish language is supported.

Prettifiers can be nested. For example if

```md
{{CONTACT `subscriber_first_name`}}
``` 

inserts `paweł` then

```md
{{CONTACT `ucfw(vocative(subscriber_first_name))`}}
``` 

will insert `Pawle`.

Prettifiers are multi-value aware. For example if

```md
{{CUSTOM `car`}}
```

inserts `honda, toyota, dodge` then

```md
{{CUSTOM `ucfw(car)`}}
``` 

will insert `Honda, Toyota, Dodge`.

---

# Randoms

Inserts random text from provided list.

```md
{{RANDOM `Hi` `Hello` `Hey`}}
```

---

# Callbacks

Callbacks allow external systems to be notified about GetResponse contact activities.

## Configuration

Callbacks can be managed using API [GET /accounts/callbacks](https://apireference.getresponse.com/#operation/getCallbacks), [POST /accounts/callbacks](https://apireference.getresponse.com/#operation/updateCallbacks) and [DELETE /accounts/callbacks](https://apireference.getresponse.com/#operation/disableCallbacks) methods or on [web interface](https://app.getresponse.com/callback).

We support SSL, so you can use either HTTP or HTTPS for callback messages.

## Parameters

Sample HTTP callback looks like this:

```http request
http://foo.bar/callback?action=open \ 
 &ACCOUNT_ID=A1&account_login=myaccount \ 
 &CAMPAIGN_ID=C1&campaign_name=mycampaign \ 
 &MESSAGE_ID=M1&message_name=My%20message&message_subject=Some%20subject \ 
 &CONTACT_ID=C1&contact_name=Friend&contact_email=friend@implix.com 
 ```
All ```*_ID``` params are compatible with corresponding identifiers in API. So for example after receiving [open](./callbacks/open) callback one may call `get_message` API method with `MESSAGE_ID` from callback to fetch additional information about opened message. Those params are case-sensitive.

## Failures

Callback timeout is 4 seconds, callbacks that are not received **are lost and will not be repeated**.

Make sure that the target server is capable of handling the expected amount of requests, especially when SSL URL is given which is more CPU-intensive.

## Support

The GetResponse Callback interface is created and maintained by the _GetResponse DevZone_ Team.

If you run into an error or you have difficulty using Callbacks please contact us using [this form](http://www.getresponse.com/feedback.html?devzone=yes) and we will provide all the support we can, in order to solve your problems.

---

# Click

## Click

_Params:_

- ```action``` - Always ```click```.
- ```ACCOUNT_ID```
- ```account_login```
- ```CAMPAIGN_ID```
- ```campaign_name```
- ```MESSAGE_ID```
- ```message_name```
- ```message_subject```
- ```LINK_ID```
- ```link_url```
- ```CONTACT_ID```
- ```contact_name``` (optional)
- ```contact_email```

---

# Goal

## Goal

_Params:_

- ```action``` - Always ```goal```.
- ```ACCOUNT_ID```
- ```account_login```
- ```CAMPAIGN_ID```
- ```campaign_name```
- ```GOAL_ID```
- ```goal_profile```
- ```goal_domain```
- ```goal_name```
- ```goal_url```
- ```CONTACT_ID```
- ```contact_name (optional)```
- ```contact_email```
- ```goal_param_0```
- ```goal_param_1 (optional)```
- ```goal_param_2 (optional)```
- ```goal_param_3 (optional)```
- ```goal_param_4 (optional)```
- ```goal_param_5 (optional)```

---

# Open

## Open

_Params:_

- ```action``` - Always ```open```.
- ```ACCOUNT_ID```
- ```account_login```
- ```CAMPAIGN_ID```
- ```campaign_name```
- ```MESSAGE_ID```
- ```message_name```
- ```message_subject```
- ```CONTACT_ID```
- ```contact_name``` (optional)
- ```contact_email```

---

# Subscribe

## Subscribe

_Params:_

- ```action``` - Always ```subscribe```.
- ```ACCOUNT_ID```
- ```account_login```
- ```CAMPAIGN_ID```
- ```campaign_name```
- ```CONTACT_ID```
- ```contact_name``` (optional)
- ```contact_email```
- ```contact_ip``` (optional) - In case of double-optin this is the IP than confirmation link was clicked from.
- ```contact_origin``` - One of ```import```, ```email```, ```www```, ```panel```, ```leads```, ```sale```, ```api```, ```forward```, ```survey```, ```iphone```, ```copy```, ```landing_page```.

---

# Survey

## Survey

_Params:_

- ```action``` - Always ```survey```.
- ```ACCOUNT_ID```
- ```account_login```
- ```CAMPAIGN_ID```
- ```campaign_name```
- ```MESSAGE_ID``` (optional) - Present if survey was sent in email message.
- ```message_name``` (optional) - Present if survey was sent in email message.
- ```message_subject``` (optional) - Present if survey was sent in email message.
- ```SURVEY_ID```
- ```survey_name```
- ```survey_title``` (optional)
- ```QUESTION_ID```
- ```question_name```
- ```question_answer``` (optional) - Present if question is of text type.
- ```OPTION_ID``` (optional) - Present if question has predetermined options to select.
- ```option_name``` (optional) - Present if question has predetermined options to select.
- ```CONTACT_ID``` (optional) - Present if survey was sent in email message.
- ```contact_name``` (optional) - Present if survey was sent in email message.
- ```contact_email``` (optional) - Present if survey was sent in email message.

::: tip
Every answer generates a separate callback. So if you have a survey with one text question, one question with a single select answer and one question with three, multi select answers you may receive up to 5 callbacks for one contact filling out this survey. It also means that the survey does not have to be completed by a contact to generate callbacks.
:::

---

# Unsubscribe

## Unsubscribe

_Params:_

- ```action``` - Always ```unsubscribe```.
- ```ACCOUNT_ID```
- ```account_login```
- ```CAMPAIGN_ID```
- ```campaign_name```
- ```CONTACT_ID```
- ```contact_name``` Field deprecated (always null). Presence only for backwards compatibility purpose.
- ```contact_email```

::: warning
This callback is generated only when a contact uses the unsubscribe link. Other removal reasons such as bounces or complaints are not reported through this callback.
:::

---

# Webhooks

## Introduction

Webhooks let you send real-time data from GetResponse to any other platform you're using. You can get notified about contact-related events, including subscribes, unsubscribes, and link clicks. [View all webhook events](#webhooks-events)

To create a webhook in your GetResponse account, go to [Webhooks](https://app.getresponse.com/webhooks/create) and click **Create webhook**. Then, pick the event and provide your webhook URL.

## Endpoint specification

Here are a few things to keep in mind when setting up and working with webhooks:
1. Your endpoint needs to be able to process HTTPS requests. So, your app needs to use HTTPS. Make sure your server has a valid SSL certificate configured and installed.
2. Your endpoint must allow requests from the available [IP addresses](https://us-ms.gr-cdn.com/ip-ranges.json). Any restrictions, such as a firewall, will prevent proper communication.
3. Your endpoint must process the request within **5 seconds**. If we don't receive a response, the webhook will timeout, and the connection will close.
4. To confirm a webhook is received, your endpoint should return one of the following 2xx HTTP status codes:
    
    - `200 OK`
    - `201 Created`
    - `202 Accepted`
    - `204 No Content`
    
5. The response body must contain JSON: `{"status": "OK"}` Without it, the request will be retried despite a 2xx status code.

::: warning
Webhooks will not work properly if the endpoint is not configured according to our endpoint specification.
:::

## Authentication

To verify a webhook request comes from GetResponse, you can add your own query string parameter at the end of your webhook URL. This will allow you to accept only the requests containing the parameter.

Your URL may look like this: `https://www.example-webhook-url.com/?secret=xyz`

::: tip NOTE
The parameter value and the name can be anything you want.
:::

## Retry policy

If the webhook request fails because of a network or server issue, we will retry 3 more times at increasing intervals.

### Requests that are retried

We retry requests for the following reasons:

- `2xx (if there's no required response body)`
- `429 (Too Many Requests )`
- `all 5xx`
- `Timeout (no response received within 5 seconds)`

### Requests that are NOT retried

We don't retry requests if your endpoint returns any for the following status codes:

- `1xx`
- `3xx (redirects)`
- `4xx (except 429)`

## Webhook batching

By default, each event is sent as an individual request, but you can merge many events into a single request. This process is known as batching.

If you expect to receive many events from your GetResponse account, we recommend you batch them to improve the performance of your integration. 

### Batch specification
- The batch size can vary, but the maximum is 100 events per batch.
- Depending on your webhook configuration and event volume, different types of webhooks can end up grouped in the same batch without any problem.
- The payload of batched webhooks is an array filled with objects representing events.
- Event objects have the typical webhook payload structure. [Learn more](payloads)

#### Payload example

```json
[
    {
       "type": "contact_opened_message",
        "contact": {
            "contactId": "abc123",
            "email": "example@example.com",
            "name": "Friend",
            "campaign": {
                "campaignId": "bcd234",
                "name": "my_first_campaign",
                "href": "https://api.getresponse.com/v3/campaigns/bcd234"
            },
            "href": "https://api.getresponse.com/v3/contacts/abc123"
        },
        "message": {
            "resourceType": "autoresponders",
            "resourceId": "cde345",
            "name": "my_first_newsletter",
            "subject": "My First Newsletter",
            "href": "https://api.getresponse.com/v3/autoresponders/cde345"
        },
        "account": {
            "accountId": "def456"
        },
        "event": {
            "occurredAt": "2021-04-27T12:56:00+00:00"
        }
    },
    {
        "type": "contact_clicked_message_link",
        "contact": {
            "contactId": "abc123",
            "email": "example@example.com",
            "name": "Friend",
            "campaign": {
                "campaignId": "bcd234",
                "name": "my_first_campaign",
                "href": "https://api.getresponse.com/v3/campaigns/bcd234"
            },
            "href": "https://api.getresponse.com/v3/contacts/abc123"
        },
        "message": {
            "resourceType": "autoresponders",
            "resourceId": "cde345",
            "name": "my_first_newsletter",
            "subject": "My First Newsletter",
            "href": "https://api.getresponse.com/v3/autoresponders/cde345"
        },
        "clickTrack": {
            "clickTrackId": "xyz789",
            "name": "Some link",
            "url": "http://example.com",
            "href": "https://api.getresponse.com/v3/click-tracks/xyz789"
        },
        "account": {
            "accountId": "def456"
        },
        "event": {
            "occurredAt": "2021-04-27T12:56:00+00:00"
        }
    }
]
```

### How to batch webhooks

1. Log into your GetResponse account and select **Webhooks** from the **Tools** menu.
1. Create a new webhook or start editing an existing one.
1. If creating a new webhook, change the webhook status to **Active**.
1. Under **Webhook batching**, switch the toggle button to **On**.
1. Save your changes.

## Webhooks events

You can configure your webhooks to send information about the following events:

- [Message opened](payloads#message-opened) - get notified **every time** a contact opens an email
- [Link clicked](payloads#link-clicked) - get notified **every time** a contact clicks a link in an email
- [SMS link clicked](payloads#sms-link-clicked) - get notified **every time** a contact clicks a link in a text message (SMS) <Badge type="warning" text="Add-on required" />
- [Contact subscribed](payloads#contact-subcribed) - get notified when a contact is added. This event is **not** triggered by imports
- [Contact copied](payloads#contact-copied) - get notified when a contact is copied
- [Contact moved](payloads#contact-moved) - get notified when a contact is moved
- [Contact unsubscribed](payloads#contact-unsubscribed) - get notified when a contact unsubscribed via unsubscribe link in an email
- [Contact bounce removed](payloads#bounced-contact-removed) - get notified when a contact is removed because of bounce.
- [Custom field value changed](payloads#custom-field-value-changed) - get notified whenever an **existing** contact has a custom field assigned, unassigned, or updated. 
  ::: tip Note
     Updates via marketing automation and contact imports do not trigger this webhook. It's also not triggered when new contacts with custom fields are added using any method.
  :::
- [Contact's email changed](payloads#contact-s-email-changed) - get notified when a contact's email address has changed
- [Import finished](payloads#contact-import-finished) - receive a notification when a contact import is complete, and receive information about the status (success/failure) of the import.
- [Contact rejected](payloads#contact-rejected) - get notified when a contact is rejected. This event is **not** triggered by imports
- [Custom report file status changed](payloads#custom_reports_file_status_changed) - get notified when a custom report is ready for download or in case an error occurs during report generation. There are only two file statuses the webhook is triggered by: `[ready, error]`.

[View Webhook payload details](payloads)

---

# Webhook payloads

##

All webhooks share the following:

- All webhooks provide data in a JSON format
- All webhooks are sent using the HTTP ```POST``` method
- All ```href``` properties link to resource details in [GetResponse APIv3](https://apireference.getresponse.com/)
- All IDs can be used with [GetResponse APIv3](https://apireference.getresponse.com/)
- Each payload contains the following fields:
  - ```type``` - event type
  - ```account``` - information **about** the account
  - ```event``` - information about the event

## Webhook headers

Each request will have the following headers:

<TwoColumnsLayout>
<template #leftContent>

```http request
Content-Type: application/json
X-Webhook-Type: contact_removed_link
X-Webhook-ID: 9b287712-80b9-4aba-ad5e-df31929dad75
X-Request-ID: cf3c768a-3465-4a6d-9ad9-ddae2705f526
```
</template>
<template #rightContent>

- `Content-Type` - Information about content type `application/json`
- `X-Webhook-Type` - Type of event. Same as `type` field from the payload
- `X-Webhook-ID` - UUID of webhook (unique per event, same for first request and retries)
- `X-Request-ID` - UUID of request (unique per request)

</template>
</TwoColumnsLayout> 


## Webhook types

### Message opened

Get notified **every time** a contact opens an email

<TwoColumnsLayout left-title="Payload example" right-title="Description">
<template #leftContent>

```json
{
  "type": "contact_opened_message",
  "contact": {
    "contactId": "abc123",
    "email": "example@example.com",
    "name": "Friend",
    "campaign": {
      "campaignId": "bcd234",
      "name": "my_first_campaign",
[...]
